// Digital Studio Test Experiments v2.0
// Motion tracking to perspective
//
// Scott Brown 6 April 2010

import processing.opengl.*;

int left;
int right;
int fillHigh = 190;
int fillLow = 20;
int alphaHigh = 190;
int alphaLow = 20;

void setup() {
  size(550, 300, OPENGL);
  smooth();
}

void draw() {
  background(0);
  noStroke();
  
  left = mouseX;
  right = mouseY;
  
  beginShape(QUADS);    // Left side perspective
  fill(fillLow, alphaHigh);
  vertex(0, 0);
  fill(fillHigh, alphaLow);
  vertex(left, height/4);
  vertex(left, height-height/4);
  fill(fillLow, alphaHigh);
  vertex(0, height);
  endShape();
  
  beginShape(QUADS);    // Right side perspective
  fill(fillHigh, alphaLow);
  vertex(right, height/4);
  fill(fillLow, alphaHigh);
  vertex(width, 0);
  vertex(width, height);
  fill(fillHigh, alphaLow);
  vertex(right, height-height/4);
  endShape();
  
  fill(fillHigh, alphaLow);
  quad(left, height/4, right, height/4, right, height-height/4, left, height-height/4);    // Middle flat
  
  if(mouseX > width/4 && mouseY < height/4) {
    fill(fillHigh, alphaLow);
    quad(0, 0, right, height/4, right, height-height/4, 0, height);
  }
  
  if(mouseX > width-width/4 && mouseY > height-height/4) {
    fill(fillHigh, alphaLow);
    quad(left, height/4, width, 0, width, height, left, height-height/4);
  }
  
  if(mouseX < width/3 && mouseX > width/4 && mouseY < height-height/3) {
    fill(fillHigh, alphaLow);
    quad(left, height/4, width, height/4, width, height-height/4, left, height-height/4);
  }
  
  if(mouseX > width/4 && mouseX < width/3 && mouseY > height-height/3) {
    fill(fillHigh, alphaLow);
    quad(left, height/4, width, height/8, width, height-height/8, left, height-height/4);
  }
  
  if(mouseX > width/2 && mouseX < width-width/3 && mouseY > width/3 && mouseY < width/2) {
    fill(fillHigh, alphaLow);
    quad(0, height/8, right, height/3, right, height-height/3, 0, height-height/8);
    quad(left, height/3, width, height/8, width, height-height/8, left, height-height/3);
    //fill(fillLow, alphaHigh);
    quad(right, height/3, left, height/3, left, height-height/3, right, height-height/3);
  }
}
